PunkObject = {}

function PunkObject:new(o)	
	o = {} or o
	setmetatable(o, self)
	self.__index = self
	return o
end

function PunkObject:set_physical_properties(w, x, y)
	self.body = love.physics.newBody(w, x, y, "dynamic")
	self.shape = love.physics.newCircleShape(5)
	
	self.fixture = love.physics.newFixture(self.body, self.shape, 1)
	self.fixture:setRestitution(0.9)
end

function PunkObject:ready(w, x, y)
	self:set_physical_properties(w, x, y)
end

function PunkObject:process(w, dt)
	
end

function PunkObject:draw()
	love.graphics.setColor(1, 1, 1)
	love.graphics.circle("fill", self.body:getX(), self.body:getY(), self.shape:getRadius())
end

