
PunkObjectModule = require("bin/class/PunkObject")

StaticModule = require("bin/class/Static")


function love.load()
	
	-- Physics
	love.physics.setMeter(64)
	--world = love.physics.newWorld(0, 9.81*64, true)
	world = love.physics.newWorld(0, 0, true)

	-- Holders
	punk_objects = {}

	-- Initial Graphics Setup
	love.graphics.setBackgroundColor(0, 0, 0)
	love.window.setMode(650, 650) -- set the window dimensions to 650 by 650
	
	-- Floor + Walls
	a = Static:new()
	a:ready(world, 10, 325, 30, 650)
	table.insert(punk_objects, a)

	b = Static:new()
	b:ready(world, 325, 640, 650, 30)
	table.insert(punk_objects, b)

	c = Static:new()
	c:ready(world, 325, 10, 650, 30)
	table.insert(punk_objects, c)

	d = Static:new()
	d:ready(world, 640, 325, 30, 650)
	table.insert(punk_objects, d)

end



function love.update(dt)

	-- Physics Update
	world:update(dt)
	
	-- Object Update
	for _, punk in pairs(punk_objects) do
		punk:process(world, dt)
	end

	-- #todo: Move this to an InputManager
	if love.keyboard.isDown('down') or love.keyboard.isDown("q")  then
		o = PunkObject:new()
		o:ready(world, love.mouse.getPosition())
		table.insert(punk_objects, o)
	end

	
end



function love.draw()
	fps = love.timer.getFPS()
	
	for _, punk in pairs(punk_objects) do
		punk:draw()
	end
	
	love.graphics.setColor(0, 0, 0)

	love.graphics.print(fps, 615, 5)
	love.graphics.print(#world:getBodies(), 5, 5)

end

function love.keypressed(key)

	if key == "g" then
		u, v = world:getGravity()

		if v == 0 then
			world:setGravity(0, 9.8*64, 0)
		else
			world:setGravity(0, 0, 0)
		end
	end
	
	
	-- Exit application
	if key == "escape" then
		love.event.quit()
	end
end
